Content.makeFrontInterface(600, 500);

const var LevelMeterL = Content.getComponent("LevelMeterL");
const var LevelMeterR = Content.getComponent("LevelMeterR");
const var LevelMeterLock = Content.getComponent("LevelMeterLock");

// show values as well, via label with whole integer db values.
const var Label_MeterValue = Content.getComponent("Label_MeterValue"); // the peak of the strongest channel. 
const var Label_MeterValue_L = Content.getComponent("Label_MeterValue_L");
const var Label_MeterValue_R = Content.getComponent("Label_MeterValue_R");



// ------------

const var Pan = Content.getComponent("Pan");

const var SimpleGain1 = Synth.getEffect("SimpleGain1");

//Decay Rate
const var DECAY_RATE = 0.93;

//Current Values
var curLevelL = 0.0;
var curLevelR = 0.0;
var curLevelM = 0.0;

//Timer Callback
const var t = Engine.createTimerObject();

t.setTimerCallback(function()
{
//Synth Values
  var LevelL = SimpleGain1.getCurrentLevel(1);  
  var LevelR = SimpleGain1.getCurrentLevel(0);
  
//Peak Synth Values  
  var peakLevelL = Math.max(LevelL, LevelL);  
  var peakLevelR = Math.max(LevelR, LevelR);
  
  var peakLevelMax = Math.max(LevelL, LevelR);

//Kick Left  
//-----------------------------------------------------------------------------  
  if (peakLevelL > curLevelL)
    {
      curLevelL = peakLevelL;
    }
  else
    {
      curLevelL *= DECAY_RATE;
    }

//Kick Right  
//-----------------------------------------------------------------------------     
  if (peakLevelR > curLevelR)
    {
      curLevelR = peakLevelR;
    }
  else
    {
      curLevelR *= DECAY_RATE;
    }
    
//Kick Max peak for mono out or label with max peak for strongest channel.
//-----------------------------------------------------------------------------     
  if (peakLevelMax > curLevelM)
    {
      curLevelM = peakLevelMax;
    }
  else
    {
      curLevelM *= DECAY_RATE;
    }

  
//Decibel Conversion  
//-----------------------------------------------------------------------------   
  LevelL = Engine.getDecibelsForGainFactor(curLevelL);  
  LevelR = Engine.getDecibelsForGainFactor(curLevelR);
  
  var LevelMax = Engine.getDecibelsForGainFactor(curLevelM);
  
//Set Values  
//-------------------------------------------------------------------------------  
  LevelMeterL.setValue(LevelL);  
  LevelMeterR.setValue(LevelR);
  
  Label_MeterValue.set("text", (LevelMax >= -99) ? Math.round(LevelMax) : -100); // use Math.round (round up) for all except minimum value, -100. 
  Label_MeterValue_L.set("text", (LevelL >= -99) ? Math.round(LevelL) : -100); // use Math.round (round up) for all except minimum value, -100. 
  Label_MeterValue_R.set("text", (LevelR >= -99) ? Math.round(LevelR) : -100); // use Math.round (round up) for all except minimum value, -100. 

  
});

t.startTimer(30);